#ifndef VMA_H
#define VMA_H

#include "types.h"
#include "riscv.h"

#define VM_ANON 0x1
#define VM_READ 0x2
#define VM_WRITE 0x4
#define VM_EXEC 0x8

struct vm_area_struct {
    struct mm_struct *vm_mm;  
    uint64 vm_start;          
    uint64 vm_end;            
    struct vm_area_struct *vm_next, *vm_prev;  
    uint64 vm_flags;          
    // struct file *vm_file;   
    uint64 vm_pgoff;          
    uint64 vm_filesz;         
};

struct mm_struct {
    struct vm_area_struct *mmap;
};

struct vm_area_struct *find_vma(struct mm_struct *mm, uint64 addr);
uint64 do_mmap(struct mm_struct *mm, uint64 addr, uint64 len, uint64 vm_pgoff, uint64 vm_filesz, uint64 flags);

#endif